package org.eclipse.incquery.uml.derivedfeatures;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import org.apache.log4j.Logger;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.incquery.runtime.api.IMatchProcessor;
import org.eclipse.incquery.runtime.api.IQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseMatcher;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.matchers.tuple.Tuple;
import org.eclipse.incquery.runtime.util.IncQueryLoggingUtil;
import org.eclipse.incquery.uml.derivedfeatures.StateIsComposite_0Match;
import org.eclipse.incquery.uml.derivedfeatures.util.StateIsComposite_0QuerySpecification;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.State;

/**
 * Generated pattern matcher API of the org.eclipse.incquery.uml.derivedfeatures.stateIsComposite_0 pattern,
 * providing pattern-specific query methods.
 * 
 * <p>Use the pattern matcher on a given model via {@link #on(IncQueryEngine)},
 * e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}.
 * 
 * <p>Matches of the pattern will be represented as {@link StateIsComposite_0Match}.
 * 
 * <p>Original source:
 * <code><pre>
 * {@literal @}QueryExplorer(checked = false)
 * pattern stateIsComposite_0(
 *     self : State,
 *     region : Region
 * ) {
 *     State.region(self, region);
 * }
 * </pre></code>
 * 
 * @see StateIsComposite_0Match
 * @see StateIsComposite_0Processor
 * @see StateIsComposite_0QuerySpecification
 * 
 */
@SuppressWarnings("all")
public class StateIsComposite_0Matcher extends BaseMatcher<StateIsComposite_0Match> {
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * 
   */
  public static StateIsComposite_0Matcher on(final IncQueryEngine engine) throws IncQueryException {
    // check if matcher already exists
    StateIsComposite_0Matcher matcher = engine.getExistingMatcher(querySpecification());
    if (matcher == null) {
    	matcher = new StateIsComposite_0Matcher(engine);
    	// do not have to "put" it into engine.matchers, reportMatcherInitialized() will take care of it
    }
    return matcher;
  }
  
  private final static int POSITION_SELF = 0;
  
  private final static int POSITION_REGION = 1;
  
  private final static Logger LOGGER = IncQueryLoggingUtil.getLogger(StateIsComposite_0Matcher.class);
  
  /**
   * Initializes the pattern matcher over a given EMF model root (recommended: Resource or ResourceSet).
   * If a pattern matcher is already constructed with the same root, only a light-weight reference is returned.
   * The scope of pattern matching will be the given EMF model root and below (see FAQ for more precise definition).
   * The match set will be incrementally refreshed upon updates from this scope.
   * <p>The matcher will be created within the managed {@link IncQueryEngine} belonging to the EMF model root, so
   * multiple matchers will reuse the same engine and benefit from increased performance and reduced memory footprint.
   * @param emfRoot the root of the EMF containment hierarchy where the pattern matcher will operate. Recommended: Resource or ResourceSet.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead, e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}
   * 
   */
  @Deprecated
  public StateIsComposite_0Matcher(final Notifier emfRoot) throws IncQueryException {
    this(IncQueryEngine.on(emfRoot));
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead
   * 
   */
  @Deprecated
  public StateIsComposite_0Matcher(final IncQueryEngine engine) throws IncQueryException {
    super(engine, querySpecification());
  }
  
  /**
   * Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @param pRegion the fixed value of pattern parameter region, or null if not bound.
   * @return matches represented as a StateIsComposite_0Match object.
   * 
   */
  public Collection<StateIsComposite_0Match> getAllMatches(final State pSelf, final Region pRegion) {
    return rawGetAllMatches(new Object[]{pSelf, pRegion});
  }
  
  /**
   * Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @param pRegion the fixed value of pattern parameter region, or null if not bound.
   * @return a match represented as a StateIsComposite_0Match object, or null if no match is found.
   * 
   */
  public StateIsComposite_0Match getOneArbitraryMatch(final State pSelf, final Region pRegion) {
    return rawGetOneArbitraryMatch(new Object[]{pSelf, pRegion});
  }
  
  /**
   * Indicates whether the given combination of specified pattern parameters constitute a valid pattern match,
   * under any possible substitution of the unspecified parameters (if any).
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @param pRegion the fixed value of pattern parameter region, or null if not bound.
   * @return true if the input is a valid (partial) match of the pattern.
   * 
   */
  public boolean hasMatch(final State pSelf, final Region pRegion) {
    return rawHasMatch(new Object[]{pSelf, pRegion});
  }
  
  /**
   * Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @param pRegion the fixed value of pattern parameter region, or null if not bound.
   * @return the number of pattern matches found.
   * 
   */
  public int countMatches(final State pSelf, final Region pRegion) {
    return rawCountMatches(new Object[]{pSelf, pRegion});
  }
  
  /**
   * Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @param pRegion the fixed value of pattern parameter region, or null if not bound.
   * @param processor the action that will process each pattern match.
   * 
   */
  public void forEachMatch(final State pSelf, final Region pRegion, final IMatchProcessor<? super StateIsComposite_0Match> processor) {
    rawForEachMatch(new Object[]{pSelf, pRegion}, processor);
  }
  
  /**
   * Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @param pRegion the fixed value of pattern parameter region, or null if not bound.
   * @param processor the action that will process the selected match.
   * @return true if the pattern has at least one match with the given parameter values, false if the processor was not invoked
   * 
   */
  public boolean forOneArbitraryMatch(final State pSelf, final Region pRegion, final IMatchProcessor<? super StateIsComposite_0Match> processor) {
    return rawForOneArbitraryMatch(new Object[]{pSelf, pRegion}, processor);
  }
  
  /**
   * Returns a new (partial) match.
   * This can be used e.g. to call the matcher with a partial match.
   * <p>The returned match will be immutable. Use {@link #newEmptyMatch()} to obtain a mutable match object.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @param pRegion the fixed value of pattern parameter region, or null if not bound.
   * @return the (partial) match object.
   * 
   */
  public StateIsComposite_0Match newMatch(final State pSelf, final Region pRegion) {
    return StateIsComposite_0Match.newMatch(pSelf, pRegion);
  }
  
  /**
   * Retrieve the set of values that occur in matches for self.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<State> rawAccumulateAllValuesOfself(final Object[] parameters) {
    Set<State> results = new HashSet<State>();
    rawAccumulateAllValues(POSITION_SELF, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for self.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<State> getAllValuesOfself() {
    return rawAccumulateAllValuesOfself(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for self.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<State> getAllValuesOfself(final StateIsComposite_0Match partialMatch) {
    return rawAccumulateAllValuesOfself(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for self.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<State> getAllValuesOfself(final Region pRegion) {
    return rawAccumulateAllValuesOfself(new Object[]{
    null, 
    pRegion
    });
  }
  
  /**
   * Retrieve the set of values that occur in matches for region.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Region> rawAccumulateAllValuesOfregion(final Object[] parameters) {
    Set<Region> results = new HashSet<Region>();
    rawAccumulateAllValues(POSITION_REGION, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for region.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Region> getAllValuesOfregion() {
    return rawAccumulateAllValuesOfregion(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for region.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Region> getAllValuesOfregion(final StateIsComposite_0Match partialMatch) {
    return rawAccumulateAllValuesOfregion(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for region.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Region> getAllValuesOfregion(final State pSelf) {
    return rawAccumulateAllValuesOfregion(new Object[]{
    pSelf, 
    null
    });
  }
  
  @Override
  protected StateIsComposite_0Match tupleToMatch(final Tuple t) {
    try {
    	return StateIsComposite_0Match.newMatch((org.eclipse.uml2.uml.State) t.get(POSITION_SELF), (org.eclipse.uml2.uml.Region) t.get(POSITION_REGION));
    } catch(ClassCastException e) {
    	LOGGER.error("Element(s) in tuple not properly typed!",e);
    	return null;
    }
  }
  
  @Override
  protected StateIsComposite_0Match arrayToMatch(final Object[] match) {
    try {
    	return StateIsComposite_0Match.newMatch((org.eclipse.uml2.uml.State) match[POSITION_SELF], (org.eclipse.uml2.uml.Region) match[POSITION_REGION]);
    } catch(ClassCastException e) {
    	LOGGER.error("Element(s) in array not properly typed!",e);
    	return null;
    }
  }
  
  @Override
  protected StateIsComposite_0Match arrayToMatchMutable(final Object[] match) {
    try {
    	return StateIsComposite_0Match.newMutableMatch((org.eclipse.uml2.uml.State) match[POSITION_SELF], (org.eclipse.uml2.uml.Region) match[POSITION_REGION]);
    } catch(ClassCastException e) {
    	LOGGER.error("Element(s) in array not properly typed!",e);
    	return null;
    }
  }
  
  /**
   * @return the singleton instance of the query specification of this pattern
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static IQuerySpecification<StateIsComposite_0Matcher> querySpecification() throws IncQueryException {
    return StateIsComposite_0QuerySpecification.instance();
  }
}
