package org.eclipse.incquery.uml.derivedfeatures.util;

import org.eclipse.incquery.runtime.api.IMatchProcessor;
import org.eclipse.incquery.uml.derivedfeatures.RedefinableElementRedefinedElementMatch;
import org.eclipse.uml2.uml.RedefinableElement;

/**
 * A match processor tailored for the org.eclipse.incquery.uml.derivedfeatures.redefinableElementRedefinedElement pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class RedefinableElementRedefinedElementProcessor implements IMatchProcessor<RedefinableElementRedefinedElementMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSource the value of pattern parameter source in the currently processed match
   * @param pTarget the value of pattern parameter target in the currently processed match
   * 
   */
  public abstract void process(final RedefinableElement pSource, final RedefinableElement pTarget);
  
  @Override
  public void process(final RedefinableElementRedefinedElementMatch match) {
    process(match.getSource(), match.getTarget());
  }
}
