package org.eclipse.incquery.uml.derivedfeatures.util;

import org.eclipse.incquery.runtime.api.IMatchProcessor;
import org.eclipse.incquery.uml.derivedfeatures.StateIsComposite_0Match;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.State;

/**
 * A match processor tailored for the org.eclipse.incquery.uml.derivedfeatures.stateIsComposite_0 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class StateIsComposite_0Processor implements IMatchProcessor<StateIsComposite_0Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSelf the value of pattern parameter self in the currently processed match
   * @param pRegion the value of pattern parameter region in the currently processed match
   * 
   */
  public abstract void process(final State pSelf, final Region pRegion);
  
  @Override
  public void process(final StateIsComposite_0Match match) {
    process(match.getSelf(), match.getRegion());
  }
}
